// 定义 install 方法，接收 Vue 作为参数。如果使用 use 注册插件，则所有的组件都将被注册
import {
  Button,
  Form,
  FormItem,
  Input,
  DatePicker,
  Collapse,
  CollapseItem,
  Switch,
  Slider,
  TimePicker,
  Rate,
  ColorPicker,
  Select,
  Option,
  Radio,
  RadioGroup,
  RadioButton,
  Checkbox,
  CheckboxGroup,
  Cascader,
  InputNumber,
  Tag
} from 'element-ui'
import Viewer from 'v-viewer'
import 'viewerjs/dist/viewer.css'
const components = [
  Button,
  Form,
  FormItem,
  Input,
  DatePicker,
  Collapse,
  CollapseItem,
  Switch,
  Slider,
  TimePicker,
  Rate,
  ColorPicker,
  Select,
  Option,
  Radio,
  RadioGroup,
  RadioButton,
  Checkbox,
  CheckboxGroup,
  Cascader,
  InputNumber,
  Tag,
  Viewer,
  SUpload,
  SFileView,
  SRichText,
  SText,
  SDict,
  STreeDict,
  SCheckTag,
  STime,
  SNumber,
  SGroupForm
]
import SUpload from './s-group-form/components/items/SUpload/upload'
import SFileView from './s-group-form/components/items/SFile/fileView'
// import SCode from './s-group-form/components/items/SAce/ace'
import SRichText from './s-group-form/components/items/SRichText/richText'
import SText from './s-group-form/components/items/SText/text'
import SDict from './s-group-form/components/items/SDict/dict'
import STreeDict from './s-group-form/components/items/SDict/treeDict'
import SCheckTag from './s-group-form/components/items/SCheckTag/checkTag'
import STime from './s-group-form/components/items/STime/time'
import SNumber from './s-group-form/components/items/SNumber/number'
import SGroupForm from './s-group-form/components/SForm/index'

const install = function (Vue) {
  // 判断是否安装
  if (install.installed) return
  // 遍历注册全局组件
  components.forEach(component => {
    Vue.component(component.name, component)
  })
  Vue.directive('change', {
    bind: function (el, binding, vnode) {
      bindEvent('change', binding, vnode.componentInstance.form)
    }
  })
  Vue.directive('blur', {
    bind: function (el, binding, vnode) {
      bindEvent('blur', binding, vnode.componentInstance.form)
    }
  })
  Vue.directive('focus', {
    bind: function (el, binding, vnode) {
      bindEvent('focus', binding, vnode.componentInstance.form)
    }
  })
}
function bindEvent (eventName, binding, form) {
  const { value, modifiers, rawName } = binding
  if (modifiers.label) {
    form.map((item) => {
      if (item.label === rawName.split('.')[2]) {
        item[eventName] = value
      }
    })
  } else if (modifiers.number) {
    form[rawName.split('.')[2]][eventName] = value
  } else {
    form.map((item) => {
      item[eventName] = value
    })
  }
}
// 判断是否是直接引入文件

if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue)
}

export default {//引入全部
  // 导出的对象必须具有 install，才能被 Vue.use() 方法安装
  install
}
export {//局部引入
  Viewer,
  SUpload,
  SFileView,
  SRichText,
  SText,
  SDict,
  STreeDict,
  SCheckTag,
  STime,
  SNumber,
  SGroupForm,
}
